; mb_ghost
; by kero, 2008-09-02

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32

.data
  _text  db "Message Box -> Ghost",0
  _nogst db "Ghost  Off",0
  _ghost db "Ghost  On",0
  _lX    db " MB  userdata:  %8.8lX",0
.data?
  usdata dd ?
.code

WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local ps:PAINTSTRUCT, rt:RECT, buf[128]:BYTE

  mov eax,uMsg
  .if eax==WM_PAINT
    invoke GetClientRect,hWnd,addr rt
    invoke BeginPaint,hWnd,addr ps
    invoke Ellipse,eax,0,0,rt.right,rt.bottom
    invoke EndPaint,hWnd,addr ps
    mov eax,FALSE
  .elseif eax==WM_SIZE
    invoke InvalidateRect,hWnd,0,1
    mov eax,FALSE
  .elseif eax==WM_CTLCOLORDLG
    invoke GetStockObject,WHITE_BRUSH
  .elseif eax==WM_COMMAND && wParam==IDHELP
    mov ebx,offset _nogst
    .if usdata==0
      inc usdata
    .else
      invoke SetWindowLong,hWnd,GWL_USERDATA,usdata
      mov usdata,eax
      .if usdata!=1
        mov ebx,offset _ghost
      .endif
    .endif
    invoke SetWindowText,lParam,ebx
    invoke GetWindowLong,hWnd,GWL_USERDATA
    invoke wsprintf,addr buf,offset _lX,eax
    invoke SetWindowText,hWnd,addr buf
    mov eax,FALSE
  .else
    invoke GetWindowLong,hWnd,DWL_USER
    invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
    .if uMsg==WM_NCHITTEST && eax==HTCLIENT
      mov eax,HTCAPTION
    .endif
  .endif
  ret
WndProc endp

EnumThreadWndProc proc hWnd:HWND,lParam:DWORD
  mov eax,lParam
  mov ecx,hWnd
  mov dword ptr [eax],ecx
  xor eax,eax
  ret
EnumThreadWndProc endp

ThreadProc proc uses ebx lParam:DWORD
  local val:DWORD
  xor eax,eax
  mov val,eax
@@:
  invoke EnumThreadWindows,lParam,addr EnumThreadWndProc,addr val
  .if val==0
    jmp @b
  .endif
  mov ebx,val
  invoke GetWindowLong,ebx,GWL_STYLE
  and eax,not DS_NOIDLEMSG
  or eax,WS_OVERLAPPEDWINDOW
  invoke SetWindowLong,ebx,GWL_STYLE,eax
  invoke GetWindowLong,ebx,GWL_EXSTYLE
  and eax,not WS_EX_DLGMODALFRAME
  or eax,WS_EX_CLIENTEDGE
  invoke SetWindowLong,ebx,GWL_EXSTYLE,eax
  invoke SetWindowPos,ebx,HWND_TOPMOST,0,0,250,150,SWP_NOMOVE or SWP_FRAMECHANGED or SWP_SHOWWINDOW
  invoke GetSystemMenu,ebx,0
  invoke GetSystemMenu,ebx,1
  invoke SetWindowLong,ebx,GWL_WNDPROC,addr WndProc
  invoke SetWindowLong,ebx,DWL_USER,eax
  invoke GetDlgItem,ebx,IDHELP
  invoke PostMessage,eax,BM_CLICK,0,0
  invoke InvalidateRect,ebx,0,1
  invoke ExitThread,0
  ret
ThreadProc endp

start:
  invoke GetCurrentThreadId
  invoke CreateThread,0,0,offset ThreadProc,eax,0,0
  invoke CloseHandle,eax
  invoke MessageBox,0,offset _text,0,MB_ICONINFORMATION or MB_HELP or MB_DEFBUTTON2 or MB_TOPMOST ; or MB_TASKMODAL
;  invoke InvalidateRect,0,0,1
  invoke ExitProcess,eax
  invoke InitCommonControls
end start
